VTK: vtkTexturedButtonRepresentation Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkTexturedButtonRepresentation Class Reference

defines a representation for a vtkButtonWidget More...

`#include <vtkTexturedButtonRepresentation.h>`

Inheritance diagram for vtkTexturedButtonRepresentation:
[legend]
Collaboration diagram for vtkTexturedButtonRepresentation:
[legend]

## Public Member Functions
virtual void | PlaceWidget (double scale, double point[3], double normal[3])
| Alternative method for placing a button at a given position (defined by point[3]); at a given orientation (normal[3], where the z-axis of the button geometry is parallel to the normal); and scaled by the scale parameter. More...
void | RegisterPickers () override
| Register internal Pickers in the Picking Manager. More...
void | SetButtonGeometry (vtkPolyData *pd)
| Set/Get the polydata which defines the button geometry. More...
void | SetButtonGeometryConnection (vtkAlgorithmOutput *algOutput)
| Set/Get the polydata which defines the button geometry. More...
vtkPolyData * | GetButtonGeometry ()
| Set/Get the polydata which defines the button geometry. More...
virtual void | SetFollowCamera (vtkTypeBool)
| Specify whether the button should always face the camera. More...
virtual vtkTypeBool | GetFollowCamera ()
| Specify whether the button should always face the camera. More...
virtual void | FollowCameraOn ()
| Specify whether the button should always face the camera. More...
virtual void | FollowCameraOff ()
| Specify whether the button should always face the camera. More...
virtual void | SetProperty (vtkProperty *p)
| Specify the property to use when the button is to appear "normal" i.e., the mouse pointer is not hovering or selecting the button. More...
virtual vtkProperty * | GetProperty ()
| Specify the property to use when the button is to appear "normal" i.e., the mouse pointer is not hovering or selecting the button. More...
virtual void | SetHoveringProperty (vtkProperty *p)
| Specify the property to use when the hovering over the button. More...
virtual vtkProperty * | GetHoveringProperty ()
| Specify the property to use when the hovering over the button. More...
virtual void | SetSelectingProperty (vtkProperty *p)
| Specify the property to use when selecting the button. More...
virtual vtkProperty * | GetSelectingProperty ()
| Specify the property to use when selecting the button. More...
void | SetButtonTexture (int i, vtkImageData *image)
| Add the ith texture corresponding to the ith button state. More...
vtkImageData * | GetButtonTexture (int i)
| Add the ith texture corresponding to the ith button state. More...
int | ComputeInteractionState (int X, int Y, int modify=0) override
| Provide the necessary methods to satisfy the vtkWidgetRepresentation API. More...
void | PlaceWidget (double bounds[6]) override
| Provide the necessary methods to satisfy the vtkWidgetRepresentation API. More...
void | BuildRepresentation () override
| Provide the necessary methods to satisfy the vtkWidgetRepresentation API. More...
void | Highlight (int state) override
| Provide the necessary methods to satisfy the vtkWidgetRepresentation API. More...
void | ShallowCopy (vtkProp *prop) override
| Provide the necessary methods to satisfy the rendering API. More...
double * | GetBounds () override
| Provide the necessary methods to satisfy the rendering API. More...
void | GetActors (vtkPropCollection *pc) override
| Provide the necessary methods to satisfy the rendering API. More...
void | ReleaseGraphicsResources (vtkWindow *) override
| Provide the necessary methods to satisfy the rendering API. More...
int | RenderOpaqueGeometry (vtkViewport *) override
| Provide the necessary methods to satisfy the rendering API. More...
int | RenderTranslucentPolygonalGeometry (vtkViewport *) override
| Provide the necessary methods to satisfy the rendering API. More...
vtkTypeBool | HasTranslucentPolygonalGeometry () override
| Provide the necessary methods to satisfy the rendering API. More...
Public Member Functions inherited from vtkButtonRepresentation
virtual void | SetNumberOfStates (int)
| Retrieve the current button state. More...
virtual int | GetState ()
| Retrieve the current button state. More...
virtual void | SetState (int state)
| Manipulate the state. More...
virtual void | NextState ()
| Manipulate the state. More...
virtual void | PreviousState ()
| Manipulate the state. More...
void | Highlight (int) override
| These methods control the appearance of the button as it is being interacted with. More...
virtual int | GetHighlightState ()
| These methods control the appearance of the button as it is being interacted with. More...
vtkButtonRepresentation * | NewInstance () const
| Standard methods for the class. More...
Public Member Functions inherited from vtkWidgetRepresentation
virtual void | PlaceWidget (double vtkNotUsed(bounds)[6])
| The following is a suggested API for widget representations. More...
virtual void | StartWidgetInteraction (double eventPos[2])
virtual void | WidgetInteraction (double newEventPos[2])
virtual void | EndWidgetInteraction (double newEventPos[2])
virtual int | GetInteractionState ()
virtual void | Highlight (int vtkNotUsed(highlightOn))
double * | GetBounds () override
| Methods to make this class behave as a vtkProp. More...
void | ShallowCopy (vtkProp *prop) override
| Shallow copy of this vtkProp. More...
void | GetActors (vtkPropCollection *) override
| For some exporters and other other operations we must be able to collect all the actors or volumes. More...
void | GetActors2D (vtkPropCollection *) override
void | GetVolumes (vtkPropCollection *) override
void | ReleaseGraphicsResources (vtkWindow *) override
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE Release any graphics resources that are being consumed by this actor. More...
int | RenderOverlay (vtkViewport *vtkNotUsed(viewport)) override
int | RenderOpaqueGeometry (vtkViewport *vtkNotUsed(viewport)) override
int | RenderTranslucentPolygonalGeometry (vtkViewport *vtkNotUsed(viewport)) override
int | RenderVolumetricGeometry (vtkViewport *vtkNotUsed(viewport)) override
vtkTypeBool | HasTranslucentPolygonalGeometry () override
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS Does this prop have some translucent polygonal geometry? This method is called during the rendering process to know if there is some translucent polygonal geometry. More...
virtual void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetRenderer (vtkRenderer *ren)
| Subclasses of vtkWidgetRepresentation must implement these methods. More...
virtual vtkRenderer * | GetRenderer ()
| Subclasses of vtkWidgetRepresentation must implement these methods. More...
virtual void | StartComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual void | ComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual void | EndComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual int | ComputeComplexInteractionState (vtkRenderWindowInteractor *iren, vtkAbstractWidget *widget, unsigned long event, void *callData, int modify=0)
virtual void | SetPlaceFactor (double)
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual double | GetPlaceFactor ()
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual void | SetHandleSize (double)
| Set/Get the factor that controls the size of the handles that appear as part of the widget (if any). More...
virtual double | GetHandleSize ()
| Set/Get the factor that controls the size of the handles that appear as part of the widget (if any). More...
virtual vtkTypeBool | GetNeedToRender ()
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
virtual void | SetNeedToRender (vtkTypeBool)
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
virtual void | NeedToRenderOn ()
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
virtual void | NeedToRenderOff ()
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
vtkWidgetRepresentation * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
Public Member Functions inherited from vtkProp
vtkProp * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | Pick ()
| Method fires PickEvent if the prop is picked. More...
virtual vtkMTimeType | GetRedrawMTime ()
| Return the mtime of anything that would cause the rendered image to appear differently. More...
virtual void | PokeMatrix (vtkMatrix4x4 *vtkNotUsed(matrix))
| These methods are used by subclasses to place a matrix (if any) in the prop prior to rendering. More...
virtual vtkMatrix4x4 * | GetMatrix ()
virtual bool | HasKeys (vtkInformation *requiredKeys)
| Tells if the prop has all the required keys. More...
virtual int | RenderVolumetricGeometry (vtkViewport *)
virtual int | RenderOverlay (vtkViewport *)
virtual bool | RenderFilteredOpaqueGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the opaque geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredTranslucentPolygonalGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the translucent polygonal geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredVolumetricGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the volumetric geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredOverlay (vtkViewport *v, vtkInformation *requiredKeys)
| Render in the overlay of the viewport only if the prop has all the requiredKeys. More...
virtual vtkTypeBool | HasOpaqueGeometry ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS Does this prop have some opaque geometry? This method is called during the rendering process to know if there is some opaque geometry. More...
virtual double | GetEstimatedRenderTime (vtkViewport *)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS The EstimatedRenderTime may be used to select between different props, for example in LODProp it is used to select the level-of-detail. More...
virtual double | GetEstimatedRenderTime ()
virtual void | SetEstimatedRenderTime (double t)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS This method is used by, for example, the vtkLODProp3D in order to initialize the estimated render time at start-up to some user defined value. More...
virtual void | RestoreEstimatedRenderTime ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS When the EstimatedRenderTime is first set to 0.0 (in the SetAllocatedRenderTime method) the old value is saved. More...
virtual void | AddEstimatedRenderTime (double t, vtkViewport *vtkNotUsed(vp))
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS This method is intended to allow the renderer to add to the EstimatedRenderTime in props that require information that the renderer has in order to do this. More...
void | SetRenderTimeMultiplier (double t)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Get/Set the multiplier for the render time. More...
virtual double | GetRenderTimeMultiplier ()
virtual void | BuildPaths (vtkAssemblyPaths *paths, vtkAssemblyPath *path)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Used to construct assembly paths and perform part traversal. More...
virtual bool | GetSupportsSelection ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Used by vtkHardwareSelector to determine if the prop supports hardware selection. More...
virtual void | ProcessSelectorPixelBuffers (vtkHardwareSelector *, std::vector< unsigned int > &)
| allows a prop to update a selections color buffers More...
virtual void | SetVisibility (vtkTypeBool)
| Set/Get visibility of this vtkProp. More...
virtual vtkTypeBool | GetVisibility ()
| Set/Get visibility of this vtkProp. More...
virtual void | VisibilityOn ()
| Set/Get visibility of this vtkProp. More...
virtual void | VisibilityOff ()
| Set/Get visibility of this vtkProp. More...
virtual void | SetPickable (vtkTypeBool)
| Set/Get the pickable instance variable. More...
virtual vtkTypeBool | GetPickable ()
| Set/Get the pickable instance variable. More...
virtual void | PickableOn ()
| Set/Get the pickable instance variable. More...
virtual void | PickableOff ()
| Set/Get the pickable instance variable. More...
virtual void | SetDragable (vtkTypeBool)
| Set/Get the value of the dragable instance variable. More...
virtual vtkTypeBool | GetDragable ()
| Set/Get the value of the dragable instance variable. More...
virtual void | DragableOn ()
| Set/Get the value of the dragable instance variable. More...
virtual void | DragableOff ()
| Set/Get the value of the dragable instance variable. More...
virtual void | SetUseBounds (bool)
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual bool | GetUseBounds ()
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual void | UseBoundsOn ()
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual void | UseBoundsOff ()
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual void | InitPathTraversal ()
| vtkProp and its subclasses can be picked by subclasses of vtkAbstractPicker (e.g., vtkPropPicker). More...
virtual vtkAssemblyPath * | GetNextPath ()
| vtkProp and its subclasses can be picked by subclasses of vtkAbstractPicker (e.g., vtkPropPicker). More...
virtual int | GetNumberOfPaths ()
| vtkProp and its subclasses can be picked by subclasses of vtkAbstractPicker (e.g., vtkPropPicker). More...
virtual vtkInformation * | GetPropertyKeys ()
| Set/Get property keys. More...
virtual void | SetPropertyKeys (vtkInformation *keys)
| Set/Get property keys. More...
virtual void | SetAllocatedRenderTime (double t, vtkViewport *vtkNotUsed(v))
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS The renderer may use the allocated rendering time to determine how to render this actor. More...
virtual double | GetAllocatedRenderTime ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS. More...
virtual int | GetNumberOfConsumers ()
| Get the number of consumers. More...
void | AddConsumer (vtkObject *c)
| Add or remove or get or check a consumer,. More...
void | RemoveConsumer (vtkObject *c)
| Add or remove or get or check a consumer,. More...
vtkObject * | GetConsumer (int i)
| Add or remove or get or check a consumer,. More...
int | IsConsumer (vtkObject *c)
| Add or remove or get or check a consumer,. More...
virtual void | SetShaderProperty (vtkShaderProperty *property)
| Set/Get the shader property. More...
virtual vtkShaderProperty * | GetShaderProperty ()
| Set/Get the shader property. More...
virtual bool | IsRenderingTranslucentPolygonalGeometry ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTexturedButtonRepresentation * | New ()
| Instantiate the class. More...
Static Public Member Functions inherited from vtkButtonRepresentation
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for the class. More...
static vtkButtonRepresentation * | SafeDownCast (vtkObjectBase *o)
| Standard methods for the class. More...
Static Public Member Functions inherited from vtkWidgetRepresentation
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkWidgetRepresentation * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
Static Public Member Functions inherited from vtkProp
static vtkTypeBool | IsTypeOf (const char *type)
static vtkProp * | SafeDownCast (vtkObjectBase *o)
static vtkInformationIntegerKey * | GeneralTextureUnit ()
| Optional Key Indicating the texture unit for general texture mapping Old OpenGL was a state machine where you would push or pop items. More...
static vtkInformationDoubleVectorKey * | GeneralTextureTransform ()
| Optional Key Indicating the texture transform for general texture mapping Old OpenGL was a state machine where you would push or pop items. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkTexturedButtonRepresentation ()
| ~vtkTexturedButtonRepresentation () override
void | CreateDefaultProperties ()
Protected Member Functions inherited from vtkButtonRepresentation
| vtkButtonRepresentation ()
| ~vtkButtonRepresentation () override
Protected Member Functions inherited from vtkWidgetRepresentation
| vtkWidgetRepresentation ()
| ~vtkWidgetRepresentation () override
void | AdjustBounds (double bounds[6], double newBounds[6], double center[3])
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the widget representation currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the registered picker, and return the assembly path. More...
vtkAssemblyPath * | GetAssemblyPath3DPoint (double pos[3], vtkAbstractPropPicker *picker)
bool | NearbyEvent (int X, int Y, double bounds[6])
double | SizeHandlesRelativeToViewport (double factor, double pos[3])
double | SizeHandlesInPixels (double factor, double pos[3])
void | UpdatePropPose (vtkProp3D *prop, const double *pos1, const double *orient1, const double *pos2, const double *orient2)
Protected Member Functions inherited from vtkProp
| vtkProp ()
| ~vtkProp () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkActor * | Actor
vtkFollower * | Follower
vtkPolyDataMapper * | Mapper
vtkTexture * | Texture
vtkTypeBool | FollowCamera
vtkProperty * | Property
vtkProperty * | HoveringProperty
vtkProperty * | SelectingProperty
vtkTextureArray * | TextureArray
vtkCellPicker * | Picker
Protected Attributes inherited from vtkButtonRepresentation
int | NumberOfStates
int | State
int | HighlightState
Protected Attributes inherited from vtkWidgetRepresentation
vtkWeakPointer< vtkRenderer > | Renderer
int | InteractionState
double | StartEventPosition [3]
double | PlaceFactor
int | Placed
double | InitialBounds [6]
double | InitialLength
int | ValidPick
bool | PickingManaged
double | HandleSize
vtkTypeBool | NeedToRender
vtkTimeStamp | BuildTime
vtkNew< vtkTransform > | TempTransform
vtkNew< vtkMatrix4x4 > | TempMatrix
Protected Attributes inherited from vtkProp
vtkTypeBool | Visibility
vtkTypeBool | Pickable
vtkTypeBool | Dragable
bool | UseBounds
double | AllocatedRenderTime
double | EstimatedRenderTime
double | SavedEstimatedRenderTime
double | RenderTimeMultiplier
int | NumberOfConsumers
vtkObject ** | Consumers
vtkAssemblyPaths * | Paths
vtkInformation * | PropertyKeys
vtkShaderProperty * | ShaderProperty
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkButtonRepresentation | Superclass
| Standard methods for instances of the class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of the class. More...
static vtkTexturedButtonRepresentation * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of the class. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instances of the class. More...
vtkTexturedButtonRepresentation * | NewInstance () const
| Standard methods for instances of the class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of the class. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instances of the class. More...

## Additional Inherited Members
Public Types inherited from vtkButtonRepresentation
enum | InteractionStateType { Outside = 0 , Inside }
typedef InteractionStateType | _InteractionState
enum | HighlightStateType { HighlightNormal , HighlightHovering , HighlightSelecting }
| These methods control the appearance of the button as it is being interacted with. More...
typedef HighlightStateType | _HighlightState
| These methods control the appearance of the button as it is being interacted with. More...
typedef vtkWidgetRepresentation | Superclass
| Standard methods for the class. More...
Public Types inherited from vtkWidgetRepresentation
enum | Axis { NONE = -1 , XAxis = 0 , YAxis = 1 , ZAxis = 2 , Custom = 3 }
| Axis labels. More...
typedef vtkProp | Superclass
| Standard methods for instances of this class. More...
Public Types inherited from vtkProp
typedef vtkObject | Superclass
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

defines a representation for a vtkButtonWidget

This class implements one type of vtkButtonRepresentation. It changes the appearance of a user-provided polydata by assigning textures according to the current button state. It also provides highlighting (when hovering and selecting the button) by fiddling with the actor's property.

To use this representation, always begin by specifying the number of button states. Then provide a polydata (the polydata should have associated texture coordinates), and a list of textures corresponding to the button states. Optionally, the HoveringProperty and SelectionProperty can be adjusted to obtain the appropriate appearance.

This widget representation has two placement methods. The conventional PlaceWidget() method is used to locate the textured button inside of a user-specified bounding box (note that the button geometry is uniformly scaled to fit, thus two of the three dimensions can be "large" and the third used to perform the scaling). However this PlaceWidget() method will align the geometry within x-y-z oriented bounds. To further control the placement, use the additional PlaceWidget(scale,point,normal) method. This scales the geometry, places its center at the specified point position, and orients the geometry's z-direction parallel to the specified normal. This can be used to attach "sticky notes" or "sticky buttons" to the surface of objects.

See also
  vtkButtonWidget vtkButtonRepresentation vtkButtonSource vtkEllipticalButtonSource vtkRectangularButtonSource

Tests:
  vtkTexturedButtonRepresentation (Tests)

Definition at line 56 of file vtkTexturedButtonRepresentation.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkButtonRepresentation vtkTexturedButtonRepresentation::Superclass

Standard methods for instances of the class.

Definition at line 68 of file vtkTexturedButtonRepresentation.h.

## Constructor & Destructor Documentation

## ◆ vtkTexturedButtonRepresentation()

vtkTexturedButtonRepresentation::vtkTexturedButtonRepresentation | ( |  | ) |
| protected

## ◆ ~vtkTexturedButtonRepresentation()

vtkTexturedButtonRepresentation::~vtkTexturedButtonRepresentation | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkTexturedButtonRepresentation* vtkTexturedButtonRepresentation::New | ( |  | ) |
| static

Instantiate the class.

## ◆ IsTypeOf()

static vtkTypeBool vtkTexturedButtonRepresentation::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instances of the class.

## ◆ IsA()

virtual vtkTypeBool vtkTexturedButtonRepresentation::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instances of the class.

Reimplemented from vtkButtonRepresentation.

## ◆ SafeDownCast()

static vtkTexturedButtonRepresentation* vtkTexturedButtonRepresentation::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instances of the class.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkTexturedButtonRepresentation::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instances of the class.

Reimplemented from vtkButtonRepresentation.

## ◆ NewInstance()

vtkTexturedButtonRepresentation* vtkTexturedButtonRepresentation::NewInstance | ( |  | ) | const

Standard methods for instances of the class.

## ◆ PrintSelf()

void vtkTexturedButtonRepresentation::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instances of the class.

Reimplemented from vtkButtonRepresentation.

## ◆ SetButtonGeometry()

void vtkTexturedButtonRepresentation::SetButtonGeometry | ( | vtkPolyData * | pd | ) |

Set/Get the polydata which defines the button geometry.

## ◆ SetButtonGeometryConnection()

void vtkTexturedButtonRepresentation::SetButtonGeometryConnection | ( | vtkAlgorithmOutput * | algOutput | ) |

Set/Get the polydata which defines the button geometry.

## ◆ GetButtonGeometry()

vtkPolyData* vtkTexturedButtonRepresentation::GetButtonGeometry | ( |  | ) |

Set/Get the polydata which defines the button geometry.

## ◆ SetFollowCamera()

virtual void vtkTexturedButtonRepresentation::SetFollowCamera | ( | vtkTypeBool |  | ) |
| virtual

Specify whether the button should always face the camera.

If enabled, the button rotates as the camera moves.

## ◆ GetFollowCamera()

virtual vtkTypeBool vtkTexturedButtonRepresentation::GetFollowCamera | ( |  | ) |
| virtual

Specify whether the button should always face the camera.

If enabled, the button rotates as the camera moves.

## ◆ FollowCameraOn()

virtual void vtkTexturedButtonRepresentation::FollowCameraOn | ( |  | ) |
| virtual

Specify whether the button should always face the camera.

If enabled, the button rotates as the camera moves.

## ◆ FollowCameraOff()

virtual void vtkTexturedButtonRepresentation::FollowCameraOff | ( |  | ) |
| virtual

Specify whether the button should always face the camera.

If enabled, the button rotates as the camera moves.

## ◆ SetProperty()

virtual void vtkTexturedButtonRepresentation::SetProperty | ( | vtkProperty * | p | ) |
| virtual

Specify the property to use when the button is to appear "normal" i.e., the mouse pointer is not hovering or selecting the button.

## ◆ GetProperty()

virtual vtkProperty* vtkTexturedButtonRepresentation::GetProperty | ( |  | ) |
| virtual

Specify the property to use when the button is to appear "normal" i.e., the mouse pointer is not hovering or selecting the button.

## ◆ SetHoveringProperty()

virtual void vtkTexturedButtonRepresentation::SetHoveringProperty | ( | vtkProperty * | p | ) |
| virtual

Specify the property to use when the hovering over the button.

## ◆ GetHoveringProperty()

virtual vtkProperty* vtkTexturedButtonRepresentation::GetHoveringProperty | ( |  | ) |
| virtual

Specify the property to use when the hovering over the button.

## ◆ SetSelectingProperty()

virtual void vtkTexturedButtonRepresentation::SetSelectingProperty | ( | vtkProperty * | p | ) |
| virtual

Specify the property to use when selecting the button.

## ◆ GetSelectingProperty()

virtual vtkProperty* vtkTexturedButtonRepresentation::GetSelectingProperty | ( |  | ) |
| virtual

Specify the property to use when selecting the button.

## ◆ SetButtonTexture()

void vtkTexturedButtonRepresentation::SetButtonTexture | ( | int | i,
|  | vtkImageData * | image
| ) |  |

Add the ith texture corresponding to the ith button state.

The parameter i should be (0 <= i < NumberOfStates).

## ◆ GetButtonTexture()

vtkImageData* vtkTexturedButtonRepresentation::GetButtonTexture | ( | int | i | ) |

Add the ith texture corresponding to the ith button state.

The parameter i should be (0 <= i < NumberOfStates).

## ◆ PlaceWidget() [1/2]

virtual void vtkTexturedButtonRepresentation::PlaceWidget | ( | double | scale,
|  | double | point[3],
|  | double | normal[3]
| ) |  |
| virtual

Alternative method for placing a button at a given position (defined by point[3]); at a given orientation (normal[3], where the z-axis of the button geometry is parallel to the normal); and scaled by the scale parameter.

This method can bs used to attach "sticky notes" or "sticky buttons" to objects. A great way to attach interactive meta-data to 3D actors.

## ◆ ComputeInteractionState()

int vtkTexturedButtonRepresentation::ComputeInteractionState | ( | int | X,
|  | int | Y,
|  | int | modify = `0`
| ) |  |
| overridevirtual

Provide the necessary methods to satisfy the vtkWidgetRepresentation API.

Reimplemented from vtkWidgetRepresentation.

## ◆ PlaceWidget() [2/2]

void vtkTexturedButtonRepresentation::PlaceWidget | ( | double | bounds[6] | ) |
| override

Provide the necessary methods to satisfy the vtkWidgetRepresentation API.

## ◆ BuildRepresentation()

void vtkTexturedButtonRepresentation::BuildRepresentation | ( |  | ) |
| overridevirtual

Provide the necessary methods to satisfy the vtkWidgetRepresentation API.

Implements vtkWidgetRepresentation.

## ◆ Highlight()

void vtkTexturedButtonRepresentation::Highlight | ( | int | state | ) |
| override

Provide the necessary methods to satisfy the vtkWidgetRepresentation API.

## ◆ ShallowCopy()

void vtkTexturedButtonRepresentation::ShallowCopy | ( | vtkProp * | prop | ) |
| overridevirtual

Provide the necessary methods to satisfy the rendering API.

Reimplemented from vtkButtonRepresentation.

## ◆ GetBounds()

double* vtkTexturedButtonRepresentation::GetBounds | ( |  | ) |
| overridevirtual

Provide the necessary methods to satisfy the rendering API.

Reimplemented from vtkProp.

## ◆ GetActors()

void vtkTexturedButtonRepresentation::GetActors | ( | vtkPropCollection * | pc | ) |
| overridevirtual

Provide the necessary methods to satisfy the rendering API.

Reimplemented from vtkProp.

## ◆ ReleaseGraphicsResources()

void vtkTexturedButtonRepresentation::ReleaseGraphicsResources | ( | vtkWindow * |  | ) |
| overridevirtual

Provide the necessary methods to satisfy the rendering API.

Reimplemented from vtkProp.

## ◆ RenderOpaqueGeometry()

int vtkTexturedButtonRepresentation::RenderOpaqueGeometry | ( | vtkViewport * |  | ) |
| overridevirtual

Provide the necessary methods to satisfy the rendering API.

Reimplemented from vtkProp.

## ◆ RenderTranslucentPolygonalGeometry()

int vtkTexturedButtonRepresentation::RenderTranslucentPolygonalGeometry | ( | vtkViewport * |  | ) |
| overridevirtual

Provide the necessary methods to satisfy the rendering API.

Reimplemented from vtkProp.

## ◆ HasTranslucentPolygonalGeometry()

vtkTypeBool vtkTexturedButtonRepresentation::HasTranslucentPolygonalGeometry | ( |  | ) |
| overridevirtual

Provide the necessary methods to satisfy the rendering API.

Reimplemented from vtkProp.

## ◆ RegisterPickers()

void vtkTexturedButtonRepresentation::RegisterPickers | ( |  | ) |
| overridevirtual

Register internal Pickers in the Picking Manager.

Must be reimplemented by concrete widget representations to register their pickers.

Reimplemented from vtkWidgetRepresentation.

## ◆ CreateDefaultProperties()

void vtkTexturedButtonRepresentation::CreateDefaultProperties | ( |  | ) |
| protected

## Member Data Documentation

## ◆ Actor

vtkActor* vtkTexturedButtonRepresentation::Actor
| protected

Definition at line 168 of file vtkTexturedButtonRepresentation.h.

## ◆ Follower

vtkFollower* vtkTexturedButtonRepresentation::Follower
| protected

Definition at line 169 of file vtkTexturedButtonRepresentation.h.

## ◆ Mapper

vtkPolyDataMapper* vtkTexturedButtonRepresentation::Mapper
| protected

Definition at line 170 of file vtkTexturedButtonRepresentation.h.

## ◆ Texture

vtkTexture* vtkTexturedButtonRepresentation::Texture
| protected

Definition at line 171 of file vtkTexturedButtonRepresentation.h.

## ◆ FollowCamera

vtkTypeBool vtkTexturedButtonRepresentation::FollowCamera
| protected

Definition at line 174 of file vtkTexturedButtonRepresentation.h.

## ◆ Property

vtkProperty* vtkTexturedButtonRepresentation::Property
| protected

Definition at line 177 of file vtkTexturedButtonRepresentation.h.

## ◆ HoveringProperty

vtkProperty* vtkTexturedButtonRepresentation::HoveringProperty
| protected

Definition at line 178 of file vtkTexturedButtonRepresentation.h.

## ◆ SelectingProperty

vtkProperty* vtkTexturedButtonRepresentation::SelectingProperty
| protected

Definition at line 179 of file vtkTexturedButtonRepresentation.h.

## ◆ TextureArray

vtkTextureArray* vtkTexturedButtonRepresentation::TextureArray
| protected

Definition at line 184 of file vtkTexturedButtonRepresentation.h.

## ◆ Picker

vtkCellPicker* vtkTexturedButtonRepresentation::Picker
| protected

Definition at line 187 of file vtkTexturedButtonRepresentation.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkTexturedButtonRepresentation.h